#pragma once

#include "Zeichnung.h"
#include "Mat3.h"
#include "Welt2D.h"

namespace Framework
{
    class Welt2D;
    class Object2D;

    class Kamera2D : public ZeichnungHintergrund
    {
    private:
        Welt2D * welt;
        Vertex wPos;
        float rotation;
        float zoom;
        Mat3< float > matrix;
        int ref;

    public:
        __declspec( dllexport ) Kamera2D();
        virtual __declspec( dllexport ) ~Kamera2D();
        __declspec( dllexport ) void setWelt( Welt2D *welt );
        __declspec( dllexport ) bool tick( double time );
        __declspec( dllexport ) void render( Bild &zRObj );
        __declspec( dllexport ) Vertex getWorldCoordinates( Punkt screenPos );
        __declspec( dllexport ) Kamera2D *getThis();
        __declspec( dllexport ) Kamera2D *release();
    };
}